"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const ag_grid_react_1 = require("ag-grid-react");
require("ag-grid-community/dist/styles/ag-grid.css");
require("ag-grid-community/dist/styles/ag-theme-alpine.css");
// convert json formatted data frame into Ag-Grid data structure 
function buildGridData(sheet_json) {
    let gridData = [];
    let columns = sheet_json.columns;
    // iterate through the data frame to get each row
    for (let i = 0; i < sheet_json.data.length; i++) {
        let rowDict = {};
        // set the index column of the Ag-Grid
        rowDict["index"] = `${i + 1}`;
        // iterate through the column to get each element
        for (let j = 0; j < sheet_json.data[i].length; j++) {
            // create dict entry for row
            let rowDictKey = columns[j];
            rowDict[rowDictKey] = sheet_json.data[i][j];
        }
        gridData.push(rowDict);
    }
    return gridData;
}
// create columns from data frame columns
function buildGridColumns(df_columns) {
    let gridColumns = [];
    // create index column
    gridColumns.push(react_1.default.createElement(ag_grid_react_1.AgGridColumn, { key: "index", headerName: "", field: "index", width: 10, lockPosition: true }));
    // iterate through columns of df_columns to create Ag-Grid columns
    df_columns.forEach((column_header) => {
        gridColumns.push(react_1.default.createElement(ag_grid_react_1.AgGridColumn, { key: column_header, field: column_header, lockPosition: true }));
    });
    return gridColumns;
}
// Render the Ag-Grid with data frame data
const MitoSheet = (props) => {
    const columns = buildGridColumns(props.sheetJSON.columns);
    const rowData = buildGridData(props.sheetJSON);
    return (react_1.default.createElement("div", { className: "ag-theme-alpine", style: { height: '200px', width: '600px' } },
        react_1.default.createElement(ag_grid_react_1.AgGridReact, { rowData: rowData }, columns)));
};
exports.default = MitoSheet;
//# sourceMappingURL=MitoSheet copy.js.map